! imperative module test cases
! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.
USING: imperative.if
       imperative.yield
       imperative.let
       imperative.invoke
       imperative.while
       io locals
       windows.types 
       kernel math.parser ; ! USING-ok (elejen a sajat modulok imperativ programozashoz...)
IN: imperative-tester

! Egyszeru hasznalat:
:: myabs  ( x -- y )
    IF x < 0 THEN{
        YIELD -x ;
    } ELSE{
        YIELD x ;
    } ;
;

! YIELD hasznalata tobb visszateresi ertek megadasahoz:
:: myswap ( x y -- y x )
    YIELD y ;
    YIELD x ;
;

! Rekurzio es egymasba agyazhatosag:
:: factorial ( x -- x! ) drop f ;  ! ( a -- b ) alaku deklaracio a forditonak, hogy a rekurziohivasnal az ellenorzes sikeres legyen (benne legyen a szimbolumtablaba)
:: factorial  ( x -- x! )
    IF x = 0 THEN{
        YIELD 1 ;
    } ELSE{
        IF x = 1 THEN{
            YIELD 1 ;
        } ELSE{
            YIELD x * factorial(x-1) ;
        } ;
    } ;
;

! rekurzio, egymasba agyazottsag es valtozohasznalat (deklaracio, olvasas, iras + lokalizacios teszt)
:: fac2 ( x -- y ) drop f ;   ! ( a -- b ) alaku deklaracio a forditonak, hogy a rekurziohivasnal az ellenorzes sikeres legyen (benne legyen a szimbolumtablaba)
:: fac2 ( x -- y )
    VAR out! ;
    IF x = 0 THEN{
        LET out! = 1 ;
    } ELSE{
        IF x = 1 THEN{
             LET out! = 1 ;
        } ELSE{
             LET out! = x * fac2(x-1) ;
        } ;
    } ;
    YIELD out ;
;

! minden eddigi egyben:
:: fac3 ( x -- success facx )
    VAR out1! ;
    IF x < 0 THEN{
        YIELD FALSE() ;
        YIELD x ;
    } ELSE{
        YIELD TRUE() ;
        IF x = 0 THEN{
            LET out1! = 1 ;
        } ELSE{
            IF x = 1 THEN{
                 LET out1! = 1 ;
            } ELSE{
                 LET out1! = x * fac2(x-1) ;
            } ;
        } ;
        YIELD out1 ;
    } ;
;

! ciklusok es fuggvenyhivasok tesztelese:
: num2str ( n -- s ) number>string ; ! ez itt csak azert kell, mert kifejezesben nem kezelunk > jelet (at kell nevezni a fuggvenyt hivashoz)
:: printnumbers ( n -- )
    VAR i! ;
    LET i! = 0 ;
    WHILE i < n DO{
        INVOKE print(num2str(i)) ;
        LET i! = i + 1 ;
    } ;
;
