! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.

USING: combinators infix.parser infix.private kernel math
multiline sequences splitting ;
IN: imperative.conditionhelper

ERROR: condition-syntax-error ;                                    ! Kivetel deklaracio feltetelben levo szintaktikai hiba esetere

: noteq ( a b -- ? ) = not ;                                       ! nemegyenlo operator (segitseg sajat magamnak)

: infix-cond-case ( seq expstr rel relstr -- seq' )                ! Ez a szo egy infix feltetelt hoz letre seq-ben expstr-bol, meghozza annak a fuggvenyeben, hogy
                                                                   ! a rel s relstr (pl. \ = es "=") parameterek micsodak. Ez a szo a megadott expstr stringbol
                                                                   ! <egyikoldal><relacio><masikoldal> jellegu felteteleket kezel le. Ezt a megadott string
                                                                   ! <relacio>-nal torteno szetbontasaval eri el!
    [ -rot ] dip                                                   ! Stack = ( rel seq expstr relstr )
    split1                                                         ! splitteljuk az expstr-t a relstr alapjan ket reszre (az elso elofordulasnal. a tobbi hibahoz
                                                                   ! vezet majd...). Tehat itt ket string keletkezik a verem tetejen levo egybol
    build-infix-ast infix-codegen prepare-operand                  ! Itt eloallitjuk a jobboldalhoz tartoz kodidezetet (az "[infix" szo forrasa alapjan)
    swap                                                           ! kicsereljuk a keletkezett idezetet es a baloldal stringjet
    build-infix-ast infix-codegen prepare-operand                  ! Itt eloallitjuk a baloldalhoz tartozo kodidezetet (az "[infix" szo forrasa alapjan)
    swap                                                           ! Stack = ( rel seq leftside rightside )

    [ suffix! ] dip                                                ! a leftside kodidezetet suffix!-eljuk a seq vegere
                                                                   ! (a dip segitsgvel, mintha a righside nem lenne ott ugy lehet vegrehajtani [ ... ] -ot)
                                                                   ! Stack = ( rel seq'' rightside )
    [ \ call suffix! ] dip                                         ! es meg kiegeszitjuk seq-et egy call-al is: Stack = ( rel seq''' rightside )
    suffix!                                                        ! ezt kovetoen pedig a jobboldalt is felirjuk a sorozat vegere + a kov. sorban egy call-t
    \ call suffix!                                                 ! Stack = ( rel seq'''' )
    swap                                                           ! Stack = ( seq'''' rel )
    suffix!                                                        ! felirjuk a relacios szot is
                                                                   ! Stack = ( seq' )
;

: infix-condition-for ( seq endstr -- seq' )                       ! Ez a szo egy sorozatba (pl. elemzesi sorozat, vagy sajat vektor) allitja elo endstr-ig
                                                                   ! az infix feltetelt
    parse-multiline-string                                         ! Eloszor beolvasunk endstr-ig (endstr pont parameterkent a vermen van ugye!)
    {                                                              ! majd ez alapjn meghivjuk megfelel parameterezessel a fenti szavat!
        { [ "!=" over subseq? ] [ \ noteq "!=" infix-cond-case ] } ! Egyedul az itt levo (noteq-es) eset erdekes kicsit, hiszen
        { [ "<=" over subseq? ] [ \ <= "<=" infix-cond-case ] }        ! jol lehet latni, hogy a ket parameter miert terhet el egymastol.
        { [ ">=" over subseq? ] [ \ >= ">=" infix-cond-case ] }        ! Itt arrol van szo, hogy az elemzest "!="-ig fogjuk vegezni, mert ezzel jelezzuk
        { [ "=" over subseq? ] [ \ = "=" infix-cond-case ] }           ! sajat nyelvkiegeszitesunkben a nem-egyenloseget, de sajat operatorkent, melyet az elemzes
        { [ "<" over subseq? ] [ \ < "<" infix-cond-case ] }           ! sikeressegekor a veremre irunk a noteq-et adjuk meg.
        { [ ">" over subseq? ] [ \ > ">" infix-cond-case ] }       ! [ "valami" over subsec? ]-ek a feltetel klozok itt. Akkor igaz, ha "valami" resze az olvasottnak)
        [ condition-syntax-error ]                                 ! ha egyik ag feltetele se ertekelodne igazra, akkor ide kerulunk, vagyis condition-syntax-error!
    } cond
;                                                                  ! Pelda forditas:
                                                                   ! ---------------
                                                                   ! factorial(5) != 120
                                                                   ! ->
                                                                   ! [ 5 factorial ] call [ 120 ] call noteq
                                                                   !
                                                                   ! myabs(-42)+(72+factorial(3)) = factorial(5)
                                                                   ! ->
                                                                   ! [ -42 myabs 72 3 factorial + + ] call [ 5 factorial ] call =
