! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.

USING: multiline splitting kernel vectors
       parser quotations
       lexer sequences
       infix combinators
       infix.private
       infix.parser
       math 
       imperative.conditionhelper ;
IN: imperative.if

ERROR: if-syntax-error ;                                ! Egy sajat kivetel deklaralasa (forditasi idoben dobaskor a fordito kiirja szovegesen ezeket!)

! Feltteles elgazs:
! --------------------
SYNTAX: IF                                              ! Az szot megtalalva a fordito az itt levoket kezdi futtatni (forditasi idoben), a stack tetejen egy sorozat
                                                        ! all, megadva az eddig elemzett szavak/ertekek listajat. Erre a szoksos suffix! muvelettel irhatunk.
          "THEN{" infix-condition-for                   ! A "THEN{"-ig olvasunk be egy infix alak feltetelt (lasd. imperative.conditionhelper)
              ! Evaluate the condition                  ! a feltetel kiertekelt formaban suffix!-olodik is nekunk az elemzesi sorba
          \ t suffix!                                   ! felirunk egy t (true) erteket az elemzesi sorba
          \ = suffix!                                   ! es utana egy = szot irunk az elemzesi sorba (vagyis a keletkezo program kiertekeli a feltetel igaz-e)
              ! Create then quotation
          1 <vector>                                    ! csinalunk egy vektort (a vektor is egy sorozat, lehet bele suffix!-olni meg ilyenek)
          \ } (parse-until)                             ! majd az ideiglenes vektorunkba parzolunk egeszen a } szoig
          >quotation suffix!                            ! es ezt atalakitjuk kodidezette, majd az elemzsi sor vgre suffix!-eljk
                                                        ! [THEN ag]

          scan-token dup ";" =                          ! beolvasunk egy tokent (string alakban kerul a stackre az eredmeny) es megnezzuk ";"-e
              [                                         ! (a) ha igen, akkor a THEN{ .. } resz utan rogton ; -vel lezarjuk az ifet es nincs else ag
                    ! create empty else quotation
                drop                                    ! ezert eldobjuk az ideiglenesen olvasott dolgot
                0 <vector> >quotation suffix!           ! csinalunk egy nullvektort, abbol egy quotation-t es az ures kodidezetet ([ ]) az elemzesi sorra irjuk
                                                        ! [ures ELSE ag]
                \ if suffix!                            ! majd felirunk az elemzesi sorba egy if-et is (tehat generaltunk egy ures else agat, ahogy kell)
              ]

              [                                         ! (b) ha nem, akkor megnezzuk, hogy "ELSE{"-et irt-e a felhasznalo
                "ELSE{" =
                [                                       ! (b1) ha igen,
                      ! create else quotation
                  1 <vector>                            ! akkor egy ideiglenes vektorba
                  \ } (parse-until)                     ! beparzoljuk a forrast a } szoig
                  >quotation suffix!                    ! kodidezette alakitjuk es rairjuk a verem tetejere
                                                        ! [ELSE ag]
                  \ if suffix!                          ! es felirunk egy if-et az elemzesi sorba
                      ! enforce ;
                  scan-token ";" =                      ! majd ellenorizzuk, hogy az if le van-e zarva pontosvesszovel (szkenneles ;-ig es stringge alakitas = -e ";")
                  [ ] [ if-syntax-error ] if            ! ha nem, akkor if-syntax-error dobasa
                ]
                [                                       ! (b2) ha nem (vagyis ha nem ELSE{-el folytatodik)
                  if-syntax-error                       ! akkor if-syntax-error dobasa
                ]
                if                                      ! Itt mar csak a fenti elagazasokhoz tartozo (itteni, factor-os) if-ek vannak kiirva....
              ]
              if                                        ! Itt mar csak a fenti elagazasokhoz tartozo (itteni, factor-os) if-ek vannak kiirva....
;                                                       ! Pelda forditasok:
                                                        ! -----------------
                                                        ! IF <cond> THEN{
                                                        !     <then-part>
                                                        ! } ELSE{
                                                        !     <else-part>
                                                        ! } ;
                                                        ! ->
                                                        ! <infix-condition-for-output> t = 
                                                        ! [ <then-part> ]
                                                        ! [ <else-part> ]
                                                        ! if
                                                        !
                                                        !
                                                        ! IF <cond> THEN{
                                                        !     <then-part>
                                                        ! } ;
                                                        ! ->
                                                        ! <infix-condition-for-output> t = 
                                                        ! [ <then-part> ]
                                                        ! [ ]
                                                        ! if
                                                        !
                                                        ! ^^ahol az <infix-condition-for-output> az imperative.conditionhelper-bol lesheto ki
