! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.

USING: multiline splitting kernel vectors
       parser quotations
       lexer sequences
       infix combinators
       infix.private
       infix.parser
       math 
       imperative.conditionhelper ;
IN: imperative.if

SYMBOL: )
ERROR: if-syntax-error ;

SYNTAX: IF
          "THEN{" infix-condition-for
              ! Evaluate the condition
          \ t suffix!
          \ = suffix!
              ! Create then quotation
          1 <vector>
          \ } (parse-until)
          >quotation suffix!

          scan-token dup ";" =
              [
                    ! create empty else quotation
                drop
                0 <vector> >quotation suffix!
                \ if suffix!
              ]
              [
                "ELSE{" =
                [
                      ! create else quotation
                  1 <vector>
                  \ } (parse-until)
                  >quotation suffix!
                  \ if suffix!
                      ! enforce ;
                  scan-token ";" =
                  [ ] [ if-syntax-error ] if
                ]
                [
                  if-syntax-error
                ]
                if
              ]
              if
;
