! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.
USING: multiline splitting kernel vectors
       parser quotations
       lexer sequences
       infix combinators
       infix.private
       infix.parser
       vocabs.parser effects
       locals.parser
       locals.errors
       math.parser locals
       math namespaces
       accessors summary ;
IN: imperative.invoke


! Sajat kivetel letrehozasa a meglevo kodhoz illeszkedve
TUPLE: retval-error { word read-only } ;                                       ! kezi kivetel-osztaly

: retval-error ( word -- * ) \ retval-error boa throw ;                        ! egy szo, hogy ugyanugy hasznalhassuk a tipusunkat a szot beirva, mint egy ERROR:-nal

M: retval-error summary                                                        ! atdefinialjuk a summary metodust
    drop
    "Invoked words must declare a stack effect with no return values!"         ! hogy a megfelelo szintaktikai hibat irja ki nekunk majd!
    ;
! Sajat kivetelkezeles eddig


! Parse + szemantikus ellenrzs: Tnyleg 0 visszatrsi rtk dolgot hvunk?
! Ehhez a reszhez meglevo kodok szemelyre szabott valtozatat hasznaljuk ([infix kodjanak bongeszese utan lesz csak ez vilagos, mert azt irjuk at itt egy hivasi uton!)
: invoke-check-word ( argcount word -- ? )                                     ! ez a fuggveny felelos a beirt szimbolumhoz valo bejegyzes ellenorzesehez
    dup stack-effect [ ] [ retval-error ] ?if                                  ! gyakorlatilag ugyanazt csinalja, mint az [infix-es valtozat ezen a szinten
    [ in>> length ] [ out>> length ] bi [ = ] dip 0 = and ;                    ! de az eredetiben itt a dip utan nem 0, hanem 1 szerepel
                                                                               ! (visszateresi ertekek szamanak ellenorzese)
                                                                               ! illetve retval error helyett masik hibajelzes...

: invoke-find-and-check ( args argcount string -- quot )                       ! Ez a fuggveny felelos a beirt szo kereseseert
    dup search [ ] [ no-word ] ?if [ nip ] [ invoke-check-word ] 2bi           ! gyakorlatilag a megfelelo [infix-es atirasa
    [ 1quotation compose ] [ retval-error ] if ;                               ! de az invoke-check-work -ot hasznaljuk a szimbulomtablaban talat szo
                                                                               ! tulajdonsagainak az ellenorzesere
                                                                               ! + retval error helyett masik hibajelzes szerepel itt az eredetiben...

: invoke-codegen ( ast -- quot )                                               ! ez a szo egy koztesen elemzett (ast) objektumbol allit elo kodidezetet
    [ arguments>> [ arguments-codegen ] [ length ] bi ]                        ! tartalmas a megfelel [infix-es fuggveny atirasa
    [ name>> ] bi invoke-find-and-check ;                                      ! hogy a sajat invoke-find-and-check -et hasznaljuk benne

: invoke-parse ( end -- quot )                                                 ! Ez a szo parzol egy invoke mogotti infix kifejezest
    parse-multiline-string build-infix-ast invoke-codegen                      ! tartalma gyakorlatilag az [infix szo atirasa csupan
    prepare-operand ;                                                          ! kiveve, hogy az invoke-codegen sajat fuggvenyt hasznaljuk ebben!
! Parse + szemantikus ellenrzs eddig

! Egy kis segito fuggveny:
: invokehelper ( quot -- ) call( -- ) ;                                        ! segito fuggveny, annak az ellenorzesere, hogy biztos ( -- ) stack effekt-u
                                                                               ! szot hivunk meg. Ezt a call( -szo tudja...

! Szintaktikus leiras:
SYNTAX: INVOKE
    ";" invoke-parse suffix!                                                   ! Ez mar ugyanugy megy, mint mondjuk egy yield..... lasd ott...
    \ invokehelper suffix!                                                     ! (a pelda-forditas is hasonlo lenne, de ugye van elotte ellenorzes)
;
! Szintaktikus leiras eddig
