! Copyright (C) 2012 Richard Thier.
! See http://factorcode.org/license.txt for BSD license.
USING: multiline splitting kernel vectors
       parser quotations
       lexer sequences
       infix combinators
       infix.private
       infix.parser
       vocabs.parser effects
       locals.parser
       locals.errors
       math.parser locals
       math namespaces
       accessors summary ;
IN: imperative.invoke


! Sajt kivtel ltrehozsa a meglv kdhoz illeszkedve
TUPLE: retval-error { word read-only } ;

: retval-error ( word -- * ) \ retval-error boa throw ;

M: retval-error summary
    drop
    "Invoked words must declare a stack effect with no return values!"
    ;
! Sajt kivtelkezels eddig


! Parse + szemantikus ellenrzs: Tnyleg 0 visszatrsi rtk dolgot hvunk?
! Ehhez a rszhez meglv kdok szemlyre szabott vltozatt hasznljuk
: invoke-check-word ( argcount word -- ? )
    dup stack-effect [ ] [ retval-error ] ?if
    [ in>> length ] [ out>> length ] bi [ = ] dip 0 = and ;

: invoke-find-and-check ( args argcount string -- quot )
    dup search [ ] [ no-word ] ?if [ nip ] [ invoke-check-word ] 2bi
    [ 1quotation compose ] [ retval-error ] if ;

: invoke-codegen ( ast -- quot )
    [ arguments>> [ arguments-codegen ] [ length ] bi ]
    [ name>> ] bi invoke-find-and-check ;

: invoke-parse ( end -- quot )
    parse-multiline-string build-infix-ast invoke-codegen
    prepare-operand ;
! Parse + szemantikus ellenrzs eddig

! Egy kis segt fggvny:
: invokehelper ( quot -- ) call( -- ) ;


! Szintaktikus lers:
SYNTAX: INVOKE
    ";" invoke-parse suffix!
    \ invokehelper suffix!
;
! Szintaktikus lers eddig
