! Copyright (C) 2012 Richard Thier
! See http://factorcode.org/license.txt for BSD license.

USING: multiline splitting kernel vectors
       parser quotations
       lexer sequences
       infix combinators
       infix.private
       infix.parser
       locals.parser
       locals.errors
       macros
       locals
       math namespaces ;
IN: imperative.let

! Ertekadas:
! ----------
SYNTAX: LET                                             ! Az szot megtalalva a fordito az itt levoket kezdi futtatni (forditasi idoben), a stack tetejen egy sorozat 
                                                        ! all, megadva az eddig elemzett szavak/ertekek listajat. Erre a szokasos suffix! muvelettel irhatunk.

    \ = parse-until                                     ! beparzoljuk a programszoveget (egy uj sorozatba) az = szoig
    >quotation                                          ! ezt a szosorozatot atalakitjuk egy kodidezette
    swap                                                ! (*) es elrejtjuk a stackben (a stack tetejen most az egesz forras elemzesi sorozata lesz, mint az elejen)
    ";" [infix-parse suffix!                            ! Az infix parsert hasznalva (egy ilyet mar valaki megirt) a ; szoig elemzunk (ez alapbl kodidezetet csinal)
                                                        ! majd ezt hozzaadjuk suffix!-el az elemzesi sorhoz [ertekadas jobbfele]
    \ call suffix!                                      ! feltesszuk az elemzesi sor vegere a call szot [ertekadas jobbfelenek a kiertekelese]
    swap                                                ! visszahozzuk a (*)-nal elrejtett elemet
    suffix!                                             ! hozzaadjuk az elemzesi sorhoz ezt is [ertekadas baloldala]
    \ call suffix!                                      ! kiertekeles [az ertekadas baloldalanak kiertekelese], ugyanis x! olyan, hogy a verem tetejen levo objektumot
;                                                       ! az x lokalis valtozoba beirja, ami nekunk pont jo lesz, ha !-el ellatott dolgot ir a user a baloldalra
                                                        ! Pelda forditas:
                                                        ! ---------------
                                                        ! LET x! = 4 + factorial(5) ;
                                                        ! ->
                                                        ! [ 4 5 factorial + ] call [ x! ] call

! Valtozodeklaracio:
! ------------------
SYNTAX: VAR                                             ! Az szot megtalalva a fordito az itt levoket kezdi futtatni (forditasi idoben), a stack tetejen egy sorozat 
                                                        ! all, megadva az eddig elemzett szavak/ertekek listajat. Erre a szokasos suffix! muvelettel irhatunk.
    f suffix!                                           ! egy f-et irunk az elemzesi sor vegere (nem kell a \ jel, mert nem az f szot, hanem az f erteket akarjuk!)
    ";" parse-tokens                                    ! parzolunk a ;-jelig, ez a szo string-vektorkent adja vissza a ;-ig talalhato dolgokat
    first                                               ! de csak az elso elem erdekel minket (ha tobb van, azok el fognak veszni a jelen verzioban...)

    locals get [ :>-outside-lambda-error ] unless*      ! ezt a reszt ugy a legkonnyebb megerteni, hogy pontosan azt csinaljuk, amit a :> csinalna,
    parse-def suffix!                                   ! tehat gyakorlatilag szinte szoszerint itt van a :> szo kodja bemasolva, de ha megnezzuk az eredetit
                                                        ! (:>, majd ctrl+h a listenerben), akkor lathatjuk, hogy ezeket megelozne meg egy stringbe torteno beolvasas
                                                        ! amit mi megcsinaltunk korabban (a ;-ig olvasassal) helyette!
;                                                       ! Pelda forditas (itt inkabb megfeleles):
                                                        ! ---------------------------------------
                                                        ! VAR x! ;
                                                        ! ->
                                                        ! f :> x!

/*
! Eredetileg ez lett volna, de ez a legtobb esetben nem muxik:
SYNTAX: LET
    "=" parse-tokens
    swap
    ";" [infix-parse suffix!
    \ call suffix!
    swap
    first
    locals get [ :>-outside-lambda-error ] unless*
    parse-def suffix!
;
! Elonye, hogy nem kell deklaralni a valtozot, de hatrany, hogy bugos :(
*/
